# coding: shift-jis

import clr
clr.AddReference("System.Windows.Forms")
clr.AddReference("System.Drawing")
from   System.Windows.Forms import *
import System.Drawing
import System.IO
import System.Text

from   cmemo_app     import *
from   cmemo_cmdmenu import *
from   cmemo_tbox    import *


class CmemoMemo(Form):

   # \ݒۑif[^t@C1sځj̍ڈʒu #
   MEMO_WID          =  0
   MEMO_HEI          =  1
   MEMO_X            =  2
   MEMO_Y            =  3
   MEMO_FONTNAME     =  4
   MEMO_FONTSIZE     =  5
   MEMO_FONTSTYLE    =  6
   MEMO_R            =  7
   MEMO_G            =  8
   MEMO_B            =  9
   MEMO_BG_R         =  10
   MEMO_BG_G         =  11
   MEMO_BG_B         =  12
   MEMO_TBOX_ENABLED =  13
   
   # EBhEbZ[W #
   WM_NCLBUTTONDBLCLK   =  0x00a3
   WM_NCRBUTTONDOWN     =  0x00a4
   WM_NCMBUTTONDOWN     =  0x00a7

   # ꗗj[̕\ #
   MENU_OWNER_MEMO   =  0
   MENU_OWNER_ICON   =  1
   
   # FontNXStylevpeB𕶎񉻂Ƃ̋؂蕶iX^Cݒ莞j #
   SPLITTER_FONT_STYLE     =  ', '     
   
   # eLXg{bNXFontStyle\ݒƂĕۑƂ̋؂蕶iX^Cݒ莞j #
   SPLITTER_FONT_STYLE_INI =  '-'      
   
   # ftHg #
   DEF_MEMO_WID            =  '200'
   DEF_MEMO_HEI            =  '100'
   DEF_MEMO_X              =  '100'
   DEF_MEMO_Y              =  '100'
   DEF_MEMO_FONTNAME       =  'MS UI Gothic'
   DEF_MEMO_FONTSIZE       =  '10.0'
   DEF_MEMO_FONTSTYLE      =  'Regular'
   DEF_MEMO_R              =  '128'
   DEF_MEMO_G              =  '255'
   DEF_MEMO_B              =  '255'
   DEF_MEMO_BG_R           =  '0'
   DEF_MEMO_BG_G           =  '0'
   DEF_MEMO_BG_B           =  '64'
   DEF_MEMO_TBOX_ENABLED   =  'True'
   
   # t@Cۑ̃؂蕶 #
   MEMO_INI_DELIMITER      =  ','
   
   # ő吔ɒBĂƂɁAVKf[^t@C̃pX̑ɕԂl #
   NO_MORE_MEMO            =  ''
   
   MAX_NUM_MEMO            =  100               # ő吔
   
   NAME_ICON               =  'cmemo_icon.ico'  # tH[pACR


   _memo_list                    =  []                # CX^XXg
   _font_dialog                  =  FontDialog()      # eLXg{bNXptHg_CAO
   _font_dialog.FontMustExist    =  True
   _font_dialog.ShowApply        =  True
   _color_dialog                 =  ColorDialog()     # eLXg{bNXpJ[_CAO
   _color_dialog.FullOpen        =  True
   
   
   def __init__(self, path):
      super(CmemoMemo, self).__init__()
   
      # t@C݃`FbN #
      path  =  path.Trim('"')
      if not System.IO.File.Exists(path):
         raise 't@C "' + path + '"݂͑܂B'
      self.file_path =  path
         
      # t@Cǂݍ #
      reader   =  System.IO.StreamReader(path, System.Text.Encoding.GetEncoding("shift-jis"))
      i        =  0
      data     =  ''
      while reader.Peek() >= 0:
         if i == 0:
            prms  =  reader.ReadLine().Split(CmemoMemo.MEMO_INI_DELIMITER)  # \ݒ擾
         else:
            data  =  reader.ReadToEnd()            # f[^擾
         i  += 1
      reader.Close()

      # tH[쐬 #
      # self.FormBorderStyle =  FormBorderStyle.Sizable
      self.Width           =  int(prms[CmemoMemo.MEMO_WID])
      self.Height          =  int(prms[CmemoMemo.MEMO_HEI])
      self._width          =  self.Width
      self._height         =  self.Height
      self.Location        =  System.Drawing.Point(int(prms[CmemoMemo.MEMO_X]), int(prms[CmemoMemo.MEMO_Y]))
      self.StartPosition   =  FormStartPosition.Manual
      self.ShowInTaskbar   =  False
      self.MaximizeBox     =  False
      self.MinimizeBox     =  False
      self.KeyPreview      =  True
      self.ControlBox      =  False
      path  =  CmemoApp.DIR_EXE + System.IO.Path.DirectorySeparatorChar + CmemoMemo.NAME_ICON
      self.Icon            =  System.Drawing.Icon(path)
      
      # eLXg{bNX쐬 #
      wid         =  self.ClientSize.Width
      hei         =  self.ClientSize.Height
      self.tbox   =  CmemoTextBox(data, wid, hei)
      
      # tHgݒ #
      name           =  prms[CmemoMemo.MEMO_FONTNAME]
      size           =  float(prms[CmemoMemo.MEMO_FONTSIZE])
      # iCmemoMemo.SPLITTER_FONT_STYLE_INIŋ؂Ă
      # tHgX^Cݒ蕶Font.Styleɍ^ɕϊj
      strs_style     =  prms[CmemoMemo.MEMO_FONTSTYLE].split(CmemoMemo.SPLITTER_FONT_STYLE_INI)
      style          =  System.Drawing.FontStyle.Regular
      for i in range(len(strs_style)):
         style =  style | self._GetFontStyleEnum(strs_style[i])
      self.tbox.Font =  System.Drawing.Font(name, size, style)
      
      # J[ݒ #
      r  =  int(prms[CmemoMemo.MEMO_R])
      g  =  int(prms[CmemoMemo.MEMO_G])
      b  =  int(prms[CmemoMemo.MEMO_B])
      self.tbox.ForeColor  =  System.Drawing.Color.FromArgb(r, g, b)
      r  =  int(prms[CmemoMemo.MEMO_BG_R])
      g  =  int(prms[CmemoMemo.MEMO_BG_G])
      b  =  int(prms[CmemoMemo.MEMO_BG_B])
      self.tbox.BackColor  =  System.Drawing.Color.FromArgb(r, g, b)
      
      # eLXg{bNX\t #
      self.Controls.Add(self.tbox)
      
      # ^CgLvVݒ #
      self._SetTitleMemoLength()
      
      # tH[pR}hj[쐬 #
      menu  =  CmemoMemoCmdMenu()
      self._SetMemoCmdMemu(menu)

      # Cxgnhݒij[ȊOj #
      self.KeyUp              += self._OnKeyUp
      self.FormClosing        += self._OnFormClosing
      self.tbox.KeyUp         += self._OnTextBoxKeyUp
      self.KeyPress           += self._OnKeyPress
      self.tbox.TextChanged   += self._OnTextBoxTextChanged
      
      # CX^XXgɎgǉ #
      CmemoMemo._memo_list.append(self)
      
      # ܂肽ݏԕ
      if prms[CmemoMemo.MEMO_TBOX_ENABLED] == str(False):   # OItbox.EnabledFalse
         self._Shrink()
         
         
   def Show(self):
      super(CmemoMemo, self).Show()
      # eLXg̑IԂĎ邽߂̃^C}[쐬 #
      self._len_selected_text =  0
      self._timer             =  Timer()
      self._timer.Interval    =  100
      self._timer.Tick        += self._OnTimerTick
      self._timer.Start()
      
      
   #------------------------#
   # EBhEvV[W #
   #------------------------#

   def WndProc(self, msg):
      if msg.Value.Msg == CmemoMemo.WM_NCLBUTTONDBLCLK:
         self._OnTitleDoubleClick()
         return
      elif msg.Value.Msg == CmemoMemo.WM_NCRBUTTONDOWN:
         self._OnTitleRightClick()
         return
      elif msg.Value.Msg == CmemoMemo.WM_NCMBUTTONDOWN:
         # ̏̕Windows̃}EXRg[pl̃zC[NbN
         # ݒ肪iI[gXN[ĵ܂܂ɂȂĂȂƎsȂB
         MessageBox.Show('_OnTitleWheelClick')
         return
      super(CmemoMemo, self).WndProc(msg)
         
         
   #------------------#
   # Cxgnh #
   #------------------#
   
   def _OnKeyUp(self, obj, eargs):
      if Form.ModifierKeys:
         if  (eargs.KeyCode  ==  Keys.N) and eargs.Control and not eargs.Shift:   # VK
            CmemoMemo._Create()
            eargs.Handled  =  True
            return
         elif  (eargs.KeyCode  ==  Keys.P) and eargs.Control and not eargs.Shift:   # Nbv{[heLXgŐVK
            CmemoMemo._CreateFromClipboard()
            eargs.Handled  =  True
            return
         elif  (eargs.KeyCode  ==  Keys.S) and eargs.Control and not eargs.Shift:   # ۑ
            self._Save()
            eargs.Handled  =  True
            return
         elif  (eargs.KeyCode  ==  Keys.S) and eargs.Control and eargs.Shift:   # ׂĕۑ
            CmemoMemo._SaveAll()
            eargs.Handled  =  True
            return
      else:
         if  eargs.KeyCode  ==  Keys.F1:     # ReadmeJ
            CmemoApp.OpenReadme()
            eargs.Handled  =  True
            return
         elif  eargs.KeyCode  ==  Keys.F11:   # ̃
            self._ActivateNext()
            eargs.Handled  =  True
            return
         elif  eargs.KeyCode  ==  Keys.F12:   # ׂđOʂ
            CmemoMemo._MoveAllToFront()
            eargs.Handled  =  True
            return
         elif  eargs.KeyCode  ==  Keys.F2:  # ׂĂ
            CmemoMemo._ShrinkAll()
            eargs.Handled  =  True
            return
         elif  eargs.KeyCode  ==  Keys.F3:  # ׂčL
            CmemoMemo._ExpandAll()
            eargs.Handled  =  True
            return
         elif  eargs.KeyCode  ==  Keys.F4:   #  / L
            self._ShrinkExpand()
            eargs.Handled  =  True
         
         
   def _OnKeyPress(self, obj, eargs):  # r[v}̂߂̏
      if  Form.ModifierKeys:
         if  eargs.KeyChar.CompareTo('n'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True
            return
         if  eargs.KeyChar.CompareTo('p'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True
            return
         if  eargs.KeyChar.CompareTo('s'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True
            return
         if  eargs.KeyChar.CompareTo('t'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True
            return
         if  eargs.KeyChar.CompareTo('b'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True
            return
         if  eargs.KeyChar.CompareTo('f'.ToCharArray()[0]) + CmemoTextBox.KEYCHAR_CONTROL == 0:
            eargs.Handled  =  True


   def _OnTextBoxKeyUp(self, obj, eargs):
      if    (eargs.KeyCode  ==  Keys.T) and eargs.Control:  # FύX
         self._ChangeFgColor()
         return
      elif  (eargs.KeyCode  ==  Keys.B) and eargs.Control:  # wiFύX
         self._ChangeBgColor()
         return
      elif  (eargs.KeyCode  ==  Keys.F) and eargs.Control:  # tHgύX
         self._ChangeFont()
         
         
   def _OnTextBoxTextChanged(self, obj, eargs):
      self._SetTitleMemoLength()
   
   
   def _OnFormClosing(self, obj, eargs):
      if eargs.CloseReason == CloseReason.UserClosing:
         # 폜̈ӎvmF #
         message  =  '̃폜܂B폜͕ł܂B폜Ă낵łH'
         caption  =  'mF'
         buttons  =  MessageBoxButtons.OKCancel
         icon     =  MessageBoxIcon.Question
         default  =  MessageBoxDefaultButton.Button2
         result   =  MessageBox.Show(self, message, caption, buttons, icon, default)
         
         if result == DialogResult.OK:
            # t@C폜 #
            System.IO.File.Delete(self.file_path)
            # Xg폜 #
            CmemoMemo._memo_list.remove(self)
         else:
            eargs.Cancel   =  True
      else:
         # AvP[VIɔ̂Ȃ̂Ńۑ #
         self._Save()
         
         
   def _OnFontDialogApply(self, obj, eargs):
      self._ApplyFontDialog()
         
         
   def _OnTimerTick(self, obj, eargs):
      self._CheckTextBoxSelectionLength()
         
         
   def _OnTitleDoubleClick(self):
      self._ShrinkExpand()
         
         
   def _OnTitleRightClick(self):
      if    Form.ModifierKeys == Keys.Control:
         self._ShowMemoListMenu()
      elif  not Form.ModifierKeys:
         self._ShowMemoCmdMenu()
         
         
   #----------------------------#
   # j[pCxgnh #
   #----------------------------#
   
   @classmethod
   def OnMenuCreate(Class, obj, eargs):
      Class._Create()
   
   @classmethod
   def OnMenuCreateFromClipboard(Class, obj, eargs):
      Class._CreateFromClipboard()
      
   @classmethod
   def OnMenuSaveAll(Class, obj, eargs):
      Class._SaveAll()

   @classmethod
   def OnMenuMoveAllToFront(Class, obj, eargs):
      Class._MoveAllToFront()
      
   @classmethod
   def OnMenuShrinkAll(Class, obj, eargs):
      Class._ShrinkAll()

   @classmethod
   def OnMenuExpandAll(Class, obj, eargs):
      Class._ExpandAll()
      
   @classmethod
   def OnMenuReadme(Class, obj, eargs):
      CmemoApp.OpenReadme()

   @classmethod
   def OnMenuExit(Class, obj, eargs):
      Application.Exit()
      
   
   def _OnMenuSave(self, obj, eargs):
      self._Save()
      
   def _OnMenuDelete(self, obj, eargs):
      self.Close()
      
   def _OnMenuNextMemo(self, obj, eargs):
      self._ActivateNext()
      
   def _OnMenuShrinkExpand(self, obj, eargs):
      self._ShrinkExpand()
      
   def _OnMenuChangeFgColor(self, obj, eargs):
      self._ChangeFgColor()

   def _OnMenuChangeBgColor(self, obj, eargs):
      self._ChangeBgColor()

   def _OnMenuChangeFont(self, obj, eargs):
      self._ChangeFont()
      
      
   def _OnMemoListMenuClick(self, obj, eargs):
      self.Activate()

      
   #----------#
   # R}h #
   #----------#
   
   # VK #
   @classmethod
   def _Create(Class):
      text  =  ''
      path  =  Class._CreateMemoFile(text)
      
      if not path == CmemoMemo.NO_MORE_MEMO:     # VKt@C쐬
         # 쐬t@C̃pXƂCmemoMemoIuWFNgE\ #
         CmemoMemo(path).Show()
         
         
   # Nbv{[heLXgŐVK #
   @classmethod
   def _CreateFromClipboard(Class):
      if Clipboard.ContainsText():     # Nbv{[hɃeLXg
         text  =  Clipboard.GetText()
      else:
         text  =  ''
      path  =  Class._CreateMemoFile(text)
      
      if not path == CmemoMemo.NO_MORE_MEMO:     # VKt@C쐬
         # 쐬t@C̃pXƂCmemoMemoIuWFNgE\ #
         CmemoMemo(path).Show()
         
         
   # ۑ #
   def _Save(self):
      #------------------------#
      # ۑf[^쐬idataj #
      #------------------------#
      
      # TCYƈʒu
      if self.tbox.Enabled:
         data  =  str(self.Width)            + CmemoMemo.MEMO_INI_DELIMITER
         data  += str(self.Height)           + CmemoMemo.MEMO_INI_DELIMITER
      else:
         data  =  str(self._width)           + CmemoMemo.MEMO_INI_DELIMITER
         data  += str(self._height)          + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.Location.X)          + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.Location.Y)          + CmemoMemo.MEMO_INI_DELIMITER
      
      # tHgݒ
      data  += self.tbox.Font.Name           + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.Font.Size) + CmemoMemo.MEMO_INI_DELIMITER
      # iX^Cݒ̋؂蕶ݒŜ̋؂蕶ƃ_uĂ邽
      # ʂ̕ɕϊŕۑj
      styles   =  str(self.tbox.Font.Style).split(CmemoMemo.SPLITTER_FONT_STYLE)
      for i in range(len(styles)):
         if i > 0:
            data  += CmemoMemo.SPLITTER_FONT_STYLE_INI
         data  += styles[i]
      data  += CmemoMemo.MEMO_INI_DELIMITER
      
      # Fݒ
      data  += str(self.tbox.ForeColor.R)    + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.ForeColor.G)    + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.ForeColor.B)    + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.BackColor.R)    + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.BackColor.G)    + CmemoMemo.MEMO_INI_DELIMITER
      data  += str(self.tbox.BackColor.B)    + CmemoMemo.MEMO_INI_DELIMITER
      
      # ܂Ă邩ǂiself.tbox.Enabled == True -> ܂ĂȂj
      data  += str(self.tbox.Enabled)        + System.Environment.NewLine
      
      # e
      data  += self.tbox.Text
   
      #--------------#
      # t@Cۑ #
      #--------------#
      file     =  System.IO.FileStream(self.file_path, System.IO.FileMode.Create)
      writer   =  System.IO.StreamWriter(file, System.Text.Encoding.GetEncoding('shift-jis'))
      writer.Write(data)
      writer.Close()
      file.Close()
      
      
   # ׂĕۑ #
   @classmethod
   def _SaveAll(Class):
      for memo in Class._memo_list:
         memo._Save()
         

   # ̃ #
   def _ActivateNext(self):
      i  =  CmemoMemo._memo_list.IndexOf(self)
      if i == len(CmemoMemo._memo_list) - 1:
         i  =  0
      else:
         i += 1
      CmemoMemo._memo_list[i].Activate()
   
   
   # ׂđOʂ #
   @classmethod
   def _MoveAllToFront(Class):
      for memo in Class._memo_list:
         memo.Activate()


   # ׂĂ #
   @classmethod
   def _ShrinkAll(Class):
      for memo in Class._memo_list:
         memo._Shrink()
   
   
   # ׂčL #
   @classmethod
   def _ExpandAll(Class):
      for memo in Class._memo_list:
         memo._Expand()
         
         
   #  / L #
   def _ShrinkExpand(self):
      if self.tbox.Enabled:
         self._Shrink()
      else:
         self._Expand()
         
         
   # FύX #
   def _ChangeFgColor(self):
      CmemoMemo._color_dialog.Color  =  self.tbox.ForeColor
      if CmemoMemo._color_dialog.ShowDialog() == DialogResult.OK:
         self.tbox.ForeColor  =  CmemoMemo._color_dialog.Color
      
      
   # wiFύX #
   def _ChangeBgColor(self):
      CmemoMemo._color_dialog.Color  =  self.tbox.BackColor
      if CmemoMemo._color_dialog.ShowDialog() == DialogResult.OK:
         self.tbox.BackColor  =  CmemoMemo._color_dialog.Color
      
      
   # tHgύX #
   def _ChangeFont(self):
      CmemoMemo._font_dialog.Font   =  self.tbox.Font
      CmemoMemo._font_dialog.Apply  += self._OnFontDialogApply
      if CmemoMemo._font_dialog.ShowDialog() == DialogResult.OK:
         self._ApplyFontDialog()
      CmemoMemo._font_dialog.Apply  -= self._OnFontDialogApply
      
      
   # ꗗj[쐬A\ #
   def _ShowMemoListMenu(self):
      menu  =  CmemoMemo.GetMemoListMenu(CmemoMemo.MENU_OWNER_MEMO)
      menu.Show(self, self.PointToClient(Cursor.Position))
   
      
   # R}hj[\ #
   def _ShowMemoCmdMenu(self):
      self.ContextMenu.Show(self, self.PointToClient(Cursor.Position))
      
      
   #--------------#
   # Tu[` #
   #--------------#

   # VKt@C쐬 #
   @classmethod
   def _CreateMemoFile(Class, text):
      # 󂫔ԍƓɃ`FbN #
      for i in range(Class.MAX_NUM_MEMO):
         path  =  CmemoApp.DIR_DATA + System.IO.Path.DirectorySeparatorChar + i.ToString('00') + '.txt'
         if System.IO.File.Exists(path):
            path  =  Class.NO_MORE_MEMO
         else:
            break
            
      if path == Class.NO_MORE_MEMO:    # Ƀ̐ς
         # print 'ȏチ邱Ƃ͂ł܂BVɂ͕svȃ폜ĉB'
         MessageBox.Show('ȏチ邱Ƃ͂ł܂BVɂ͕svȃ폜ĉB')
         return path
         
      # 󂫔ԍ𖼑OƂăeLXgt@C쐬 #
      data  =  Class.DEF_MEMO_WID            + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_HEI            + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_X              + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_Y              + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_FONTNAME       + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_FONTSIZE       + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_FONTSTYLE      + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_R              + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_G              + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_B              + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_BG_R           + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_BG_G           + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_BG_B           + Class.MEMO_INI_DELIMITER
      data  += Class.DEF_MEMO_TBOX_ENABLED   + System.Environment.NewLine
      data  += text
      
      file     =  System.IO.FileStream(path, System.IO.FileMode.Create)
      writer   =  System.IO.StreamWriter(file, System.Text.Encoding.GetEncoding('shift-jis'))
      writer.Write(data)
      writer.Close()
      file.Close()

      return path


   #  #
   def _Shrink(self):
      if self.tbox.Enabled:
         self.Text            =  self._GetMemo1stLine() + ' '   # Xy[XǉȂƂȂ
         self.tbox.Enabled    =  False
         # ޑÕTCYL^ĂAFormBorderStyleƃTCYύX #
         self._width          =  self.Width
         self._height         =  self.Height
         self.FormBorderStyle =  FormBorderStyle.Fixed3D
         self.Width           =  self._width
         self.Height          =  0
         # OύXnj[𖳌 #
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFONT].Enabled    =  False
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGBGCLR].Enabled   =  False
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFGCLR].Enabled   =  False
   
   
   # L #
   def _Expand(self):
      if not self.tbox.Enabled:
         self._SetTitleMemoLength()
         self.tbox.Enabled    =  True
         # FormBorderStyle߂ĂTCYύX #
         self.FormBorderStyle =  FormBorderStyle.Sizable
         self.Width           =  self._width
         self.Height          =  self._height
         self.tbox.Focus()
         # OύXnj[L #
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFONT].Enabled    =  True
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGBGCLR].Enabled   =  True
         self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFGCLR].Enabled   =  True
         
         
   def _GetFontStyleEnum(self, str_style):
      if    str_style == str(System.Drawing.FontStyle.Bold):
         return  System.Drawing.FontStyle.Bold
      elif  str_style == str(System.Drawing.FontStyle.Italic):
         return  System.Drawing.FontStyle.Italic
      elif  str_style == str(System.Drawing.FontStyle.Underline):
         return  System.Drawing.FontStyle.Underline
      elif  str_style == str(System.Drawing.FontStyle.Strikeout):
         return  System.Drawing.FontStyle.Strikeout
      else:
         return  System.Drawing.FontStyle.Regular
         
         
   # FontDialog̓eeLXg{bNXijɔf #
   def _ApplyFontDialog(self):
      self.tbox.Font =  CmemoMemo._font_dialog.Font
         
         
   # Ŝ܂͑IeLXg̒^Cgo[ɕ\ #
   def _SetTitleMemoLength(self):
      if self.tbox.SelectionLength == 0:
         text     =  self.tbox.Text
      else:
         text     =  self.tbox.SelectedText
      len         =  System.Text.Encoding.GetEncoding("shift-jis").GetBytes(text).Length
      self.Text   =  str(len) + 'oCg'
      
      
   def _CheckTextBoxSelectionLength(self):
      if self.tbox.SelectionLength != self._len_selected_text:
         self._SetTitleMemoLength()
         self._len_selected_text =  self.tbox.SelectionLength
      

   # 1sڂ擾 #
   def _GetMemo1stLine(self):
      len   =  self.tbox.Text.IndexOf(System.Environment.NewLine)
      if len < 0:
         return self.tbox.Text
      else:
         return self.tbox.Text.Substring(0, len)
         
         
   def _SetMemoCmdMemu(self, menu):
      self.ContextMenu  =  menu
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_NEW].Click       += CmemoMemo.OnMenuCreate
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_NEWCLIP].Click   += CmemoMemo.OnMenuCreateFromClipboard
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_SAVE].Click      += self._OnMenuSave
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_SAVEALL].Click   += CmemoMemo.OnMenuSaveAll
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_DELETE].Click    += self._OnMenuDelete
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_NEXTMEMO].Click  += self._OnMenuNextMemo
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_FRONTALL].Click  += CmemoMemo.OnMenuMoveAllToFront
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_SRKALL].Click    += CmemoMemo.OnMenuShrinkAll
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_XPDALL].Click    += CmemoMemo.OnMenuExpandAll
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_SRKXPD].Click    += self._OnMenuShrinkExpand
      
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFGCLR].Click  += self._OnMenuChangeFgColor
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGBGCLR].Click  += self._OnMenuChangeBgColor
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_CHGFONT].Click   += self._OnMenuChangeFont
      
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_README].Click    += CmemoMemo.OnMenuReadme
      self.ContextMenu.MenuItems[CmemoMemoCmdMenu.IDX_MEMO_MENU_EXIT].Click      += CmemoMemo.OnMenuExit

   
   # ꗗj[쐬 #
   @classmethod
   def GetMemoListMenu(Class, owner):
      menu  =  ContextMenu()
      if owner == Class.MENU_OWNER_MEMO:
         item         =  MenuItem()
         item.Text    =  MENU_TEXT_CANCEL
         menu.MenuItems.Add(item)
         item         =  MenuItem()
         item.Text    =  MENU_TEXT_BORDER
         menu.MenuItems.Add(item)
      for memo in Class._memo_list:
         item         =  MenuItem()
         item.Text    =  memo._GetMemo1stLine()
         item.Click   += memo._OnMemoListMenuClick
         menu.MenuItems.Add(item)
      if owner == Class.MENU_OWNER_ICON:
         item         =  MenuItem()
         item.Text    =  MENU_TEXT_BORDER
         menu.MenuItems.Add(item)
         item         =  MenuItem()
         item.Text    =  MENU_TEXT_CANCEL
         menu.MenuItems.Add(item)
      return menu
