# coding: shift-jis

import clr
clr.AddReference("System.Windows.Forms")
from   System.Windows.Forms import *
import System


class MyTextBox(TextBox):

   _list_menu_text   =  []
   _list_menu_text.append('؂(T)\tCtrl+X')
   _list_menu_text.append('Rs[(C)\tCtrl+C')
   _list_menu_text.append('\t(P)\tCtrl+V')
   _list_menu_text.append('폜(D)\tDelete')
   _list_menu_text.append('-')
   _list_menu_text.append('ɖ߂(U)\tCtrl+Z')
   _list_menu_text.append('-')
   _list_menu_text.append('ׂđI(A)\tCtrl+A')
   
   IDX_MENU_CUT         =  0
   IDX_MENU_COPY        =  1
   IDX_MENU_PASTE       =  2
   IDX_MENU_DELETE      =  3
   IDX_MENU_UNDO        =  5
   IDX_MENU_SELECTALL   =  7

   KEYCHAR_CONTROL      =  96


   def __init__(self):
      super(MyTextBox, self).__init__()

      self.ContextMenu  =  self._CreateContextMenu()

      self.KeyPress     += self._OnKeyPress
      
      
   def _CreateContextMenu(self):
   
      menu  =  ContextMenu()
      
      for text in MyTextBox._list_menu_text:
         item        =  MenuItem()
         item.Text   =  text
         menu.MenuItems.Add(item)
      menu.MenuItems[MyTextBox.IDX_MENU_CUT].Click       +=  self._OnMenuCut
      menu.MenuItems[MyTextBox.IDX_MENU_COPY].Click      +=  self._OnMenuCopy
      menu.MenuItems[MyTextBox.IDX_MENU_PASTE].Click     +=  self._OnMenuPaste
      menu.MenuItems[MyTextBox.IDX_MENU_DELETE].Click    +=  self._OnMenuDelete
      menu.MenuItems[MyTextBox.IDX_MENU_UNDO].Click      +=  self._OnMenuUndo
      menu.MenuItems[MyTextBox.IDX_MENU_SELECTALL].Click +=  self._OnMenuSelectAll
      return menu
      
      
   def _OnMenuUndo(self, obj, eargs):
      self.Undo()
   
   def _OnMenuCut(self, obj, eargs):
      self.Cut()
   
   def _OnMenuCopy(self, obj, eargs):
      self.Copy()
   
   def _OnMenuPaste(self, obj, eargs):
      self.Paste()
   
   def _OnMenuDelete(self, obj, eargs):
      self.SelectedText =  ''
   
   def _OnMenuSelectAll(self, obj, eargs):
      self.SelectAll()
      
      
   # ɗLɂ@\sƋɃr[v}
   def _OnKeyPress(self, obj, eargs):
      if  Form.ModifierKeys:
         if  eargs.KeyChar.CompareTo('a'.ToCharArray()[0]) + MyTextBox.KEYCHAR_CONTROL == 0:
            self.SelectAll()
            eargs.Handled  =  True
